<?php
/*
Plugin Name: Smsbox – Notify Customers & Admin by SMS
Plugin URI: http://www.smsbox.gr
Version: 1.0.0
Description: This extension will integrate SMS features into your WooCommerce store for free. When an order is placed, completed or status changed you can confirm with your customer and/or store admin via a text message (sms) sent directly to their mobile phone.
Author: Smsbox
Tested up to: 4.9.8
Author URI: http://www.smsbox.gr
Text Domain: smsbox
*/


if ( !defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
    error_reporting(E_ALL);
    if ( in_array( 'woocommerce_smsbox/smsbox.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
        if ( 'impossible_default_value_1234' === get_option( 'wp_smsbox_username', 'impossible_default_value_1234' ) ) {
            add_option('wp_smsbox_username','');
            add_option('wp_smsbox_password','');
            add_option('wp_smsbox_config');
        }
    }
    // load default methods
    add_action( 'admin_enqueue_scripts','load_assets');
    add_action('admin_post_add_smsbox', 'add_username_pass');
    add_action('admin_menu', 'Smsbox_setup_menu');

    function Smsbox_setup_menu(){
        add_menu_page( 'Smsbox Plug-in', 'Smsbox', 'manage_options', 'woocommerce_smsbox', 'woocommerce_smsbox_init' ,'dashicons-email-alt' );
    }

    // get credits
    function get_credits(){
        $url = 'http://www.smsbox.gr/httpapi/getbalance.php?username='.get_option( 'wp_smsbox_username' ).'&password='.get_option( 'wp_smsbox_password' );
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $output = curl_exec($ch);
        curl_close($ch);

        $output_int = (int)$output;
        return $output_int;

    }
    function load_assets(){
        wp_enqueue_style( 'smsbox-style', plugins_url( 'assets/css/style.css', __FILE__ ), false, date( 'Ymd' ) );
        wp_enqueue_style( 'smsbox-style-validation', plugins_url( 'assets/css/validationEngine.jquery.css', __FILE__ ), false, date( 'Ymd' ) );
        wp_enqueue_script( 'smsbox-script', plugins_url( 'assets/js/script.js', __FILE__ ), array( 'jquery' ), false, true );
        wp_enqueue_script( 'smsbox-script-validation', plugins_url( 'assets/js/jquery.validationEngine.js', __FILE__ ), array( 'jquery' ), false, true );
        wp_enqueue_script( 'smsbox-script-validation-language', plugins_url( 'assets/js/jquery.validationEngine-en.js', __FILE__ ), array( 'jquery' ), false, true );
    }
    function add_username_pass() {
        if($_POST['wp_smsbox_username']!=''&& $_POST['wp_smsbox_password']!=''){
            $wp_smsbox_config = $_POST['wp_smsbox_config'];

            $wp_smsbox_config['admin_message_onhold']      = substr(sanitize_text_field($wp_smsbox_config['admin_message_onhold']),0,918);
            $wp_smsbox_config['admin_message_pending']      = substr(sanitize_text_field($wp_smsbox_config['admin_message_pending']),0,918);
            $wp_smsbox_config['admin_message_processing']      = substr(sanitize_text_field($wp_smsbox_config['admin_message_processing']),0,918);
            $wp_smsbox_config['admin_message_complete']      = substr(sanitize_text_field($wp_smsbox_config['admin_message_complete']),0,918);
            $wp_smsbox_config['admin_message_cancelled']      = substr(sanitize_text_field($wp_smsbox_config['admin_message_cancelled']),0,918);
            $wp_smsbox_config['admin_message_refunded']      = substr(sanitize_text_field($wp_smsbox_config['admin_message_refunded']),0,918);
            $wp_smsbox_config['admin_message_failed']      = substr(sanitize_text_field($wp_smsbox_config['admin_message_failed']),0,918);

            $wp_smsbox_config['customer_message_onhold']   = substr(sanitize_text_field($wp_smsbox_config['customer_message_onhold']),0,918);
            $wp_smsbox_config['customer_message_pending']   = substr(sanitize_text_field($wp_smsbox_config['customer_message_pending']),0,918);
            $wp_smsbox_config['customer_message_processing']   = substr(sanitize_text_field($wp_smsbox_config['customer_message_processing']),0,918);
            $wp_smsbox_config['customer_message_complete']   = substr(sanitize_text_field($wp_smsbox_config['customer_message_complete']),0,918);
            $wp_smsbox_config['customer_message_cancelled']   = substr(sanitize_text_field($wp_smsbox_config['customer_message_cancelled']),0,918);
            $wp_smsbox_config['customer_message_refunded']   = substr(sanitize_text_field($wp_smsbox_config['customer_message_refunded']),0,918);
            $wp_smsbox_config['customer_message_failed']   = substr(sanitize_text_field($wp_smsbox_config['customer_message_failed']),0,918);

            $wp_smsbox_config['sender_id_admin']    = substr(sanitize_text_field($wp_smsbox_config['sender_id_admin']),0,11);
            $wp_smsbox_config['sender_id_customer'] = substr(sanitize_text_field($wp_smsbox_config['sender_id_customer']),0,11);

            $wp_smsbox_config['new_customer_message']           = substr(sanitize_text_field($wp_smsbox_config['new_customer_message']),0,918);
            $wp_smsbox_config['new_customer_admin_message']     = substr(sanitize_text_field($wp_smsbox_config['new_customer_admin_message']),0,918);
            $wp_smsbox_config['sender_id_new_customer']         = substr(sanitize_text_field($wp_smsbox_config['sender_id_new_customer']),0,11);
            $wp_smsbox_config['sender_id_new_customer_admin']   = substr(sanitize_text_field($wp_smsbox_config['sender_id_new_customer_admin']),0,11);

            $wp_smsbox_config['notify_admin']               = ((intval($wp_smsbox_config['notify_admin']))?$wp_smsbox_config['notify_admin']:'');
            $wp_smsbox_config['notify_customer']            = ((intval($wp_smsbox_config['notify_customer']))?$wp_smsbox_config['notify_customer']:'');
            $wp_smsbox_config['notify_new_customer']        = ((intval($wp_smsbox_config['notify_new_customer']))?$wp_smsbox_config['notify_new_customer']:'');
            $wp_smsbox_config['notify_new_customer_admin']  = ((intval($wp_smsbox_config['notify_new_customer_admin']))?$wp_smsbox_config['notify_new_customer_admin']:'');

            preg_match('/^(?![0-9\s]*$)[a-zA-Z0-9\s]+$/',$wp_smsbox_config['sender_id_admin'],$admin_sender_id);
            preg_match('/^(?![0-9\s]*$)[a-zA-Z0-9\s]+$/',$wp_smsbox_config['sender_id_customer'],$customer_sender_id);


            if((!empty($admin_sender_id) || $wp_smsbox_config['sender_id_admin']=='') && (!empty($customer_sender_id ) || $wp_smsbox_config['sender_id_customer']=='')){
                $wp_smsbox_config['admin_mobile']                       = validate_mobile_numbers($wp_smsbox_config['admin_mobile']);
                $wp_smsbox_config['smsbox_new_customer_admin_mobile']   = validate_mobile_numbers($wp_smsbox_config['smsbox_new_customer_admin_mobile']);
                update_option('wp_smsbox_username',sanitize_text_field($_POST['wp_smsbox_username']));
                update_option('wp_smsbox_password',sanitize_text_field($_POST['wp_smsbox_password']));
                update_option('wp_smsbox_config',$wp_smsbox_config);
                wp_redirect('admin.php?page=woocommerce_smsbox');
            }else{
                $error_message = 'Alphanumeric_value_are_allowed_with_sender_id';
                add_settings_error('general', 'settings_updated', $error_message, 'error');
                wp_redirect('admin.php?page=woocommerce_smsbox&error='.$error_message);
            }
        }else{
            $error_message = 'Please_enter_username_and_password';
            add_settings_error('general', 'settings_updated', $error_message, 'error');
            wp_redirect('admin.php?page=woocommerce_smsbox&error='.$error_message);
        }
    }
    function validate_mobile_numbers($admin_numbers){
        $number = '';
        $admin_numbers_arr = explode(',',$admin_numbers);
        foreach ($admin_numbers_arr as $key => $val) {
            if($val !='' && intval($val)){
                //preg_match('/^(07)[\d]{9}$/',$val,$match);
                preg_match('/^(69)[\d]{8}$/',$val,$match);
                if($match[0]!=''){
                    $number .= $match[0].',';
                }
            }
        }
        return trim($number,',');
    }
    function woocommerce_smsbox_init(){
        if(get_option( 'wp_smsbox_username' )!='' && get_option( 'wp_smsbox_password' )!=''){
            $config = array();
            $config['username'] = get_option( 'wp_smsbox_username' );
            $config['password'] = get_option( 'wp_smsbox_password' );
        }
        include_once dirname( __FILE__ ) . "/template/settings.php";
    }
}

include_once dirname(__FILE__) . "/smsbox_config.php";
